#!/usr/local/bin/perl -w
use CGI qw(param);

# set up months arrays

@months = qw(January February March April May June July August September October November December);
@doymon = qw(0 31 59 90 120 151 181 212 243 273 304 334 365);
@doymon_lp = qw(0 31 60 91 121 152 182 213 244 274 305 335 366);
$filler = "&nbsp";

# find present year and month; should work even after yr 2K
# since PERL will say year 2003 is 103; mon=0 is January

$mon = param("month_picked");
$year = param("year_picked");
if (param()) {
  $year = $year + 1900;
} else {
  ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime;
  $year = $year + 1900;
}

# find days since end of 1997 (start of calendar) to start of
# present month ; so $days_since_1997 is 0 for January 1, 1998

$deltayr = $year - 1998;
$days_since_1997 = 0;
while ($deltayr > 0) {
  $thisyear = 1997 + $deltayr;
  $lpyr = $thisyear % 4;
  if ($lpyr == 0) {
    $days_since_1997 = $days_since_1997 + 366;
  } else {
    $days_since_1997 = $days_since_1997 + 365;
  }
  $deltayr--;
}
$lpyr = $year % 4;
if ($lpyr == 0) {
  $days_since_1997 = $days_since_1997 + $doymon_lp[$mon];
  $numdays = $doymon_lp[$mon+1] - $doymon_lp[$mon];
} else {
  $days_since_1997 = $days_since_1997 + $doymon[$mon];
  $numdays = $doymon[$mon+1] - $doymon[$mon];
}

# form will have only 3 years listed, starting with 98

$next_year = $year + 1;
$prev_year = $year - 1;
$next_yr = $next_year - 1900;
$prev_yr = $prev_year - 1900;
$yr = $year - 1900;

# now find $startday = doy of week of first of this month
# Jan 1, 1998 is a Thursday; a startday of 0 is a Sunday

$startday = ( (4 + $days_since_1997) % 7 );

# now read in the DB itself (assumes it is already sorted) from
# the file calendar.db.  i will be the number of old entries.

open (CALDB, "<calendar.db") || die "Can't open calendar.db: $!\n";
$i = 0;
while (<CALDB>) {
  $test_mon = substr($_, 4, 2);
  $test_yr = substr($_, 0, 4);
  if ($test_mon == $mon && $test_yr == $year) {
    $i++;
    $dbline_1[$i] = $_;
    $dbline_2[$i] = <CALDB>;
    $dbdetails[$i] = <CALDB>;
    $dbwebpage[$i] = <CALDB>;
    $dbdom[$i] = substr($dbline_1[$i], 6, 2);
    $dbtime[$i] = substr($dbline_1[$i], 8, 5);
    $next_dbdom = $dbdom[$i] if ($i == 1);
    ($dummy, $dbname[$i], $dbtitle[$i]) = split(/:/,$dbline_1[$i]);
    ($dbemail[$i], $dbphone[$i], $dblocation[$i]) = split(/:/,$dbline_2[$i]);
    chomp($dbtitle[$i]);
    chomp($dblocation[$i]);
    chomp($dbdetails[$i]);
    chomp($dbwebpage[$i]);
  } elsif (($test_mon > $mon && $test_yr >= $year) || $test_yr > $year) {
    last;
  }
}
close (CALDB) || die "Can't close the calendar.db: $!\n";
$next_dbdom = $numdays+1 if ($i == 0);

print(stdout <<"EOM1");
Content-type: text/html

<html>
<head>
<title>The University of Arizona Physics Department Monthly Calendar Page</title>
</head>

<body background=http://www.physics.arizona.edu/physics/images/parchback.gif text=#000000 link=#0000FF vlink=#FF0000>

<center>
<TABLE>

<td colspan=4 align=center>
<img src=http://www.physics.arizona.edu/physics/images/physics5.gif alt="The Department of Physics" vspace=0><br>
</td></tr>
</TABLE>
</center>
<br>

<p>                                                                             
<h1>                                                                            
<center>                                                                        
Departmental Events                                                             
</center>                                                                       
</h1>                                                                           
<br><hr><br><p>
                                                                                
<CENTER>
<TABLE BORDER=1 CELLPADDING=1 CELLSPACING=1>
 <TR>
   <TH COLSPAN=7><FONT SIZE=+5>$months[$mon] $year</FONT></TH>
 </TR>
 <TR>
   <TH WIDTH=80>Sunday</TH>
   <TH WIDTH=80>Monday</TH>
   <TH WIDTH=80>Tuesday</TH>
   <TH WIDTH=80>Wednesday</TH>
   <TH WIDTH=80>Thursday</TH>
   <TH WIDTH=80>Friday</TH>
   <TH WIDTH=80>Saturday</TH>
 </TR>
 <TR>
EOM1
if ($startday > 0) {
  $daycnt = $startday;
  while ($daycnt > 0) {
    $daycnt--;
    print "   <TD HEIGHT=80 ALIGN=center VALIGN=top>$filler</TD>\n";
  }
}
$weekday = $startday;
$dom = 1;
#
# skip empty days at start of month
#
while ($dom < $next_dbdom)  {
        PrintEmptyDay();
}
#
# if there are any entries for this month, start putting em in
#
if ( $i > 0 ) {
  for ($j = 1; $j <= $i; $j++) {
    if ($j == 1 || $dbdom[$j] > $dbdom[$j-1]) {
      StartDay();
    }
    $tmstr = "        ";
    if ($dbtime[$j] ne "     ") {
      $hrstr = substr($dbtime[$j],0,2);
      $hrstr = substr($dbtime[$j],1,1) if ($hrstr < 10);
      $tmstr = $hrstr . ":" . substr($dbtime[$j],2,2);
      if (substr($dbtime[$j],4,1) eq "a" ) {
        $tmstr = $tmstr . " AM";
      } else {
        $tmstr = $tmstr . " PM";
      }
    }
    print "    <FONT SIZE=-1><B>$tmstr</B></FONT>  ";
    if ($dbwebpage[$j] ne "" && $dbwebpage [$j] ne "No WebPage") {
      print "    <FONT SIZE=-1><A HREF=\"$dbwebpage[$j]\">$dbtitle[$j]</A></FONT><BR>\n";
    } else {
      $newpage_str = "make_page.cgi?cname=".$dbname[$j].
                  "&details=".$dbdetails[$j].
                  "&cemail=".$dbemail[$j].
                  "&cphone=".$dbphone[$j].
                  "&location=".$dblocation[$j].
                  "&title=".$dbtitle[$j];
      $newpage_str =~ s/ /+/g;
      print "    <FONT SIZE=-1><A HREF=\"$newpage_str\">$dbtitle[$j]</A></FONT><BR>\n";
    }
    if ($j == $i || $dbdom[$j+1] > $dbdom[$j]) {
      EndDay();
      if ($j < $i) {
        $next_dbdom = $dbdom[$j+1];
      } else {
        $next_dbdom = $numdays+1;
      }
      while ($dom < $next_dbdom)  {
        PrintEmptyDay();
      }
    }
  }
  PrintEmptyDay() while ($dom <= $numdays);
}
#
# finish the calendar off
#
FinishCal();

print(stdout <<"EOM3");

<br>                                                                            
<p><hr>                                                                         

You may view another month if you wish:
<form action="http://newton.physics.arizona.edu/~rfc/calendar_monthly.cgi" action=get>
<input type="submit" name="submit" value="View this Month:">
<select name="month_picked">
EOM3

# select next month as default month to view

$nxtmon = ($mon + 1) % 12;
for ( $i = 0; $i <= 11; $i++) {
  if ($i < $nxtmon || $i > $nxtmon) {
    print "<option value=\"$i\">$months[$i]\n";
  } else {
    print "<option selected value=\"$i\">$months[$nxtmon]\n";
  }
}
  
print "</select>\n";
print "<select name=\year_picked\>\n";

if ($mon == 11) {
$prev_year = $year;
$year = $next_year;
$next_year++;
$prev_yr = $yr;
$yr = $next_yr;
$next_yr++;
}

# no calendar data prior to January, 1998

if ($prev_year >= 1998) {
  print "<option value=\"$prev_yr\">$prev_year\n";
}

print(stdout <<"EOM4");
<option selected value="$yr">$year
<option value="$next_yr">$next_year
</select>
</form>
<p>
You may also see the Department's <A HREF="http://newton.physics.arizona.edu/~rfc/calendar_weekly.cgi">
weekly calendar</a>

<p>
This Calendar lists all events from January 1, 1998 on.  Click on
the name of an event to find out event details.
If you wish to add anything to the Dept Calendar, fill out this
<a href="calendar_form.cgi">form</a>.
</body>
                                                                                
<tail>
<hr>
<font size=3>
<center>
<p><a href="http://www.physics.arizona.edu/cgi-bin/imagemap/barmap">
<img src=http://www.physics.arizona.edu/physics/images/bar2.gif border=0 align=center ISMAP></a>
<br>[<a href=http://www.physics.arizona.edu/physics/search.html>Search</a> | 
<a href=http://www.physics.arizona.edu/physics/>Home</a> | 
<a href=http://www.physics.arizona.edu/physics/feedback.html>Feedback</a>]
</center>
</font>
</tail>
<br><p>
<font size=1>
Last Modified: June 26, 1998.
<address>
Send questions about the Calendar to Alaina, our Communications Director /
<a href="mailto:alaina\@physics.arizona.edu">Alaina\@physics.arizona.edu</a>
<br>
Page maintained by Robert Coker / 
<a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>
</address>
<p>Send comments to <a href=mailto:webmaster\@physics.arizona.edu><i>Webmaster</i></a>
</font>
</html>                                                                         
EOM4

sub StartDay {
# Prints the current day cell -- leaves open for data if needed
  print(stdout <<"STDY");
   <TD HEIGHT=80 ALIGN=center VALIGN=top>
     <TABLE BORDER=0>
       <TR>
       <TD>$dom</TD>
       </TR>
     </TABLE>
STDY
  }

sub EndDay {
# Finish off the listing for a day and increment $dom, $weekday vars
  print "   </TD>\n";
  $dom++; 
  $weekday++;
  if ($weekday > 6)  {     # We have reached the end of the week.  End this week.
        print "  </TR>\n";   # End the week
        $weekday = 0;      # Reset counter to Sunday    
    if ($dom<=$numdays) {  # if more days to go, start new week
          print "  <TR>\n";
    }
  }
}

sub PrintEmptyDay {
# Prints the empty current day and updates the $dom and $weekday variables
  StartDay();
  EndDay();
}

sub FinishCal {
# Finishes off the calendar by closing the table 
  $daycnt = 7 - $weekday;
  if ($weekday != 0) {
    while ($daycnt > 0) {
      $daycnt--;
      print "   <TD HEIGHT=80 ALIGN=center VALIGN=top>$filler</TD>\n";
    }
    print "  </TR>\n";
  }
  print "</TABLE>\n";
  print "</CENTER>\n";
}
