#!/usr/local/bin/perl
#
# This program takes its input from a web form for requesting 
# an addition to the dept calendar; info is mailed to rfc@physics
#
#
# Determine the parameters passed to the program from the form
# [the file 'formlib.pl' must exist in this directory]
#
require "formlib.pl";
&GetFormArgs;
#
# Set up arrays for the date.
#
@month = qw(January February March April May June July August September October November December);
@dayname = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday);
@daysinmon = qw(31 28 31 30 31 30 31 31 30 31 30 31);
($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime;
$year += 1900;
$date_of_request = "$dayname[$wday], $month[$mon] $mday, $year";
$time_of_request = sprintf("%d:%2.2d:%2.2d",$hour,$min,$sec);
#
# Determine the hostname of the posting computer.  Note that this info
# is supposedly passed to the cgi in the environment, but it seems to be
# always IP no. encoded.  This determines the name through gethostbyaddr()
#
($a,$b,$c,$d) = split(/\./,$ENV{'REMOTE_ADDR'});
$addr = pack('C4',$a,$b,$c,$d);
($name,$aliases,$addrtype,$length,@addrs) = gethostbyaddr($addr,2);
# 
# profs who fill out the form apparently can't remember to not use a CR
# on the details section so strip all \n's from 'details' and turn em
# into spaces [this doesn't seem to be working!].
# Also, change all double quotes to single ones and '=' to 'equals'.
#
$grr = "\014";
$in{'detail'} =~ s/\n/ /g;
$in{'detail'} =~ s/\"/\'/g;
$in{'detail'} =~ s/\=/ equals /g;
$in{'detail'} =~ s/$grr/ /g;
#
# Did the user fill out the required info?
# check for sufficient days in picked month;
# check for ":"'s in some of the fields (calendar won't parse correctly);
#

$index=0;
if($in{'yr'} eq "")
{
    @missing[$index++]="Year of the event";
} else 
{
    $yr = $in{'yr'} % 4;
    $daysinmon[1]++ if ($yr == 0) ;
}

if($in{'month'} eq "")
{
    @missing[$index++]="Month of the event";
} 

if($in{'day'} eq "")
{
    @missing[$index++]="Day of the event";
} 
else 
{
    if ($in{'month'} ne "") 
    {
        if ($in{'day'} > $daysinmon[$in{'month'}])
        {
            @missing[$index++]="There are not $in{'day'} days in $month[$in{'month'}]";
        }
    }
    if ($in{'day'} < 10) {
      $in{'day'} = "0".$in{'day'};
    }
}

if($in{'cname'} eq "")
{
    @missing[$index++]="Contact's name";
} 
elsif ($in{'cname'} =~ /:/ || $in{'cname'} =~ /\@/ )
{
    @missing[$index++]="No colon (:) or at-sign (\@) in Contact's name, please";
}

if($in{'title'} eq "")
{
    @missing[$index++]="Short name for event";
} 
elsif ($in{'title'} =~ /:/ || $in{'title'} =~ /\@/ )
{
    @missing[$index++]="No colon (:) or at-sign (\@) in event title, please";
}

if ($in{'cemail'} eq "")
{
    @missing[$index++]="Contact's email address";
}
elsif ($in{'cemail'} =~ /:/)
{
    @missing[$index++]="No colon (:) in Contact's email, please";
}

if ($in{'cphone'} =~ /:/)
{
    @missing[$index++]="No colon (:) in Contact's phone, please";
}

if ($in{'location'} =~ /:/)
{
    @missing[$index++]="No colon (:) in event location, please";
}

if($index != 0) {&FormIncompleteError();}

#
# Send info to calendar guru
#

&OpenError($!) 
unless open(MAILTO,"| mailx -s \"$in{'cname'} has a calendar event \" rfc\@physics.arizona.edu");
print(MAILTO <<"EOM");

On $date_of_request at $time_of_request, $in{'cname'} made
an event request from $name ($ENV{'REMOTE_ADDR'}).

--xx START xx--
  Year of event:          $in{'yr'}
  Month of event:         $month[$in{'month'}]
  Day of event:           $in{'day'}
  Time of event:          $in{'timehr'}:$in{'timemin'}$in{'timeampm'}
  Location of event:      $in{'location'}
  Contact Name:           $in{'cname'}
  Contact Email Address:  $in{'cemail'}
  Contact phone number:   $in{'cphone'}
  Brief description:      $in{'title'}
  xx Detailed description xx: 
$in{'detail'}
  xx Webpage xx:
$in{'page'}
--xx END xx--
EOM

print(MAILTO <<"EOM");

EOM

close MAILTO;

#
# Inform the user that all is well, assuming it is...
#

print(stdout <<"EOM");
Content-type: text/html

<html>
<head>
<title>Your Calendar Event Request has been forwarded</title>
</head>

<body bgcolor="#ffffff">
<hr size=5>

<h1>
<center>
Your request has been forwarded
</center>
</h1>

<hr size=5>

<p>

Dear $in{'cname'} (if that is really you):<p>

<font size=+2>T</font>hanks for putting in an Event for the
Physics Department Calendar.
<p>

Sincerely,<p>

<blockquote>
	The Calendar Robot
</blockquote>


Request Received at $time_of_request on $date_of_request MST<br>
Posted from $name<p>

<hr size=5>
<h5>
<center>
Last Modified: November 5, 1998<br>
The Calendar Organizer | <a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>
</center>
</h5>
</body>
</html>

EOM

#
# That should be it!
#

#
# Handle the error if one develops.
#

sub OpenError
{
	local($TheError) = @_;
	print <<"EOM";
Content-type: text/html

<html>
<head>
<title>Oops!  There's Been An Error!</title>
</head>

<body bgcolor="#ffffff">
<hr size=5>
<center>
<h1>Oops!  There's Been An Error!</h1>
</center>
<hr size=5>

Howdy.  Unfortunately, a problem has devloped, and I don't know what to do
about it.  Please contact
<a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>
and report the following:<p>

<h2>$TheError</h2>

Thanks a bunch!<p>

<blockquote>
	The Calendar Robot
</blockquote>

<hr size=5>
<h5>
<center>
Last Modified: September 5, 1998<br>
The Calendar Organizers | <a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>
</center>
</h5>
</body>
</html>
EOM

	exit;
}

#
# FormIncompleteError() - Generate a page explaining what information the
# user still needs to supply...
#

sub FormIncompleteError
{
	print <<"EOM";
Content-type:	text/html

<html>
<head>
<title>Sorry!  We need more info!</title>
</head>

<body bgcolor="#ffffff">
<hr size=5>
<center>
<h1>Sorry!  We need more info!</h1>
</center>
<hr size=5>

We require more information from you in order to correctly process your
calendar event.  Please use your browser's "Go Back" command to return to the
event form and supply or fix the following information:<p>

<blockquote>
  <ul>
EOM

	for($i=0;$i<$index;$i++)
	{
		print "    <li> ",@missing[$i],"\n";
	}

	print <<"EOM";
  </ul>
</blockquote>
<hr size=5>
<strong>If your browser does not have a "Go Back" command</strong>: You can
return to the form via 
<a href="http://newton.physics.arizona.edu/~rfc/calendar_form.cgi">this link</a>, 
but be warned that it will reload the form from
scratch, and you will have to resupply <em>all</em> information.  This
is the fault of your browser.<p>

<hr size=5>
If you require additional help, please send email to
<a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>.

<hr size=5>
<h5>
<center>
Last Modified: September 5, 1998<br>
The Calendar Organizer | <a href="mailto:rfc\@physics.arizona.edu">rfc\@physics.arizona.edu</a>
</center>
</h5>
</body>
</html>
EOM
	exit;
}

#
# format for MAILTO's formatted output...
#

format MAILTO =
        ^<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<~~
$text
.
